'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = finishOp;

var _mapping = require('../mapping');

var _mapping2 = _interopRequireDefault(_mapping);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function finishOp(inner) {
  return function ha(type, size) {
    var str = this.input.slice(this.pos, this.pos + size);
    var converted = Array.from(str).map(function (s) {
      return _mapping2.default[s.charCodeAt()];
    }).join('');
    if (converted.length < size) {
      return inner.call(this, type, size);
    }
    this.pos += size;
    return this.finishToken(type, converted);
  };
}
module.exports = exports['default'];