'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _astring = require('astring');

var _astring2 = _interopRequireDefault(_astring);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Create a custom generator that inherits from Astring's default generator
var customGenerator = Object.assign({}, _astring2.default.defaultGenerator, {
  Literal: function Literal(node, state) {
    if (node.raw != null) {
      var first = node.raw.charAt(0).charCodeAt();
      var last = node.raw.charAt(node.raw.length - 1).charCodeAt();

      if (first === 12300 && last === 12301 || // 「」
      first === 8216 && last === 8217) {
        // ‘’
        state.output.write('\'' + node.raw.slice(1, node.raw.length - 1) + '\'');
      } else if (first === 12302 && last === 12303 || // 『』
      first === 8220 && last === 8221) {
        // “”
        state.output.write('"' + node.raw.slice(1, node.raw.length - 1) + '"');
      } else if (first === 34 && last === 34 || first === 39 && last === 39) {
        // "" or ''
        state.output.write(node.raw);
      } else {
        // HaLang-specific string literals
        state.output.write(node.value);
      }
    } else if (node.regex != null) {
      this.RegExpLiteral(node, state);
    } else {
      state.output.write(JSON.stringify(node.value));
    }
  }
});

exports.default = customGenerator;
module.exports = exports['default'];